### Running test against ipf-test.arbetsformedlingen.se
If you have not installed the ipf-test.arbetsformedlingen.se certificate chain into the Java keystore, follow the instructions below

1. Download CA certificate from the server

```bash
echo quit | openssl s_client -showcerts -servername ipf-test.arbetsformedlingen.se -connect ipf-test.arbetsformedlingen.se:443 > ipftest_cacert.pem 
```

2. Find the path to the cacerts file in your Java installation. (`<JAVA_HOME>/lib/security/cacerts`)

```bash
sudo keytool -import -alias ipf-test -file ipftest_cacert.pem -keystore <cacerts file>
```

### Test the connection to the arbetssökande-api with

```bash
curl --cacert ipftest_cacert.pem -v\
  -H "AF-TrackingId: cecc6c34-d5a0-431e-b190-2ec45a4261e6"\
  -H "AF-SystemId: IPF"\
  -H "AF-EndUserId: mydat"\
  -H "AF-Environment: T1"\
  "https://ipf-test.arbetsformedlingen.se/ais-f-arbetssokande/v1/arbetssokande/sok?client_id=a5b2869a20d94c0e9b66d09bd4d39fac&client_secret=<secret>&Personnummer=199010102383"
```
Ask someone in the team for the secret...

### Local Docker Compose environment
We expect **java 17**, **maven** and podman to be installed in the local dev environment.
If you use Docker then replace the **podman** command with **docker**

Neede certificates has to be provided in the **certs** folder.

To generate local client key pair:
```
$ openssl genrsa -out certs/local-client.pem 4096 
$ openssl rsa -in certs/local-client.pem -pubout -outform DER -out certs/local-client-public.key 
$ openssl pkcs8 -topk8 -inform PEM -in certs/local-client.pem -outform DER -out certs/local-client-private.key -nocrypt 
```
To generate the server key pair:
```
$ openssl genrsa -out certs/server.pem 4096 
$ openssl rsa -in certs/server.pem -pubout -outform DER -out certs/server-public.key 
$ openssl pkcs8 -topk8 -inform PEM -in certs/server.pem -outform DER -out certs/server-private.key -nocrypt 
```

An .env.dev file is also expected. Take a look at the .env.dev.example file.

Compile the application:
```
mvn clean package -DskipTests
```

Start environment with:
```
podman compose -f docker-compose.dev.yml up
```

### Start local server with
```
mvn spring-boot:run -Dspring-boot.run.profiles=local
```

### Run all tests

```
$ mvn test
```

#### Run only unit tests

```
$ mvn test-compile surefire:test@unit
```

#### Run only integration tests

```
$ mvn test-compile surefire:test@integration
```

### Code coverage

Code coverage reports can be generated by using the Maven JaCoCo plugin:
```
mvn clean jacoco:prepare-agent install jacoco:report
```
Open the report in a browser with:
```
open target/site/jacoco/index.html
```

